LeetCode 11 Container With Most Water

Container With Most Water

 

Given n non-negative integers a1a2, ..., an, where each represents a point at coordinate (iai). n vertical lines are drawn such that the two endpoints of line i is at (iai) and (i, 0). Find two lines, which together with x-axis forms a container, such that the container contains the most water.

Note: You may not slant the container.

解法思路:题目大意是以x轴 ,两个以 顶点在( i ai )、(j, aj)到x轴的垂直直线所围成的凹槽的面积的最大值。

暴力法,O(n^2) 的复杂度,两层循环遍历所有节点,找到最大值。但是明显超时了,因此,需要改进。

在这里设置两个指针,分别从最左边和最右边遍历。然后进行判断,若出现左边低于右边高度时,将左边指针加1.若出现左边高于右边的时候,则右边加1.
这里这样做的原因是,当出现较低的高度的时候,替换这个低的高度,从而遍历寻找高的高度来提高面积。如果以相反的做法,则不能提高面积。
暴力法代码如下:
int maxArea1(int* height, int heightSize){
	int max = 0;
	for (int i = 0; i < heightSize; i++){
		int t = heightSize - 1;
		while (t>=i)
		{
			int h = height[i]>height[t] ? height[t] : height[i];
			int temp = (t-i)*h;
			if (temp >= max){
				max = temp;
			}
			t--;
		}
	}
	return max;
}

双指针代码如下:复杂度O(n)
int maxArea(int *height, int heightSize){
	int max = 0;
	int left = 0;
	int right = heightSize-1;
	while (left < right){
		int h = height[left]>height[right] ? height[right] : height[left];
		int temp = (right - left)*h;
		if (temp >= max){
			max = temp;
		}
		if (height[left] > height[right]){
			right--;
		}
		else{
			left++;
		}
	}
	return max;
}


  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
题目"leetcode 11"是一个关于容器装水的问题。给定一个非负整数数组height,数组的每个元素表示当前位置的高度。我们需要在数组中选择两个位置,在这两个位置之间形成的容器可以容纳最多的水。要求返回容器的最大容量。 根据引用中的代码,我们可以使用双指针的方法来解决这个问题。首先,我们初始化两个指针,一个指向数组的头部,一个指向数组的尾部。然后,我们计算当前两个指针所形成的容器的容量,即两个指针之间的距离乘以两个指针所对应的高度中较小的一个。我们将计算得到的容量与之前的最大容量进行比较,更新最大容量的值。接下来,我们移动指针的规则是,如果左指针所对应的高度小于右指针所对应的高度,则将左指针向右移动一位;之,如果右指针所对应的高度小于左指针所对应的高度,则将右指针向左移动一位。我们重复这个过程,直到左指针和右指针相遇为止。 通过这种方法,我们可以找到最大的容器装水量,并将其作为结果返回。根据引用和引用中的代码示例,我们可以实现以下的算法来解决这个问题: ```java public static int maxArea(int[] height) { int left = 0; int right = height.length - 1; int maxArea = 0; while (left < right) { int currentArea = Math.min(height[left], height[right]) * (right - left); maxArea = Math.max(maxArea, currentArea); if (height[left < height[right]) { left++; } else { right--; } } return maxArea; } ``` 这个算法的时间复杂度是O(N),其中N是给定数组的长度。算法使用了双指针的方法,每次移动指针都可以排除一些不可能形成最大容器的情况,从而减少了不必要的计算。这使得算法具有较高的效率。 综上所述,根据给定的引用内容,我们可以使用双指针的方法来解决"leetcode 11"这个问题,找到数组中能够容纳最多水的容器的容量。<span class="em">1</span><span class="em">2</span><span class="em">3</span> #### 引用[.reference_title] - *1* [leetcode11-leetCode:leetcode](https://download.csdn.net/download/weixin_38665490/19947831)[target="_blank" data-report-click={"spm":"1018.2226.3001.9630","extra":{"utm_source":"vip_chatgpt_common_search_pc_result","utm_medium":"distribute.pc_search_result.none-task-cask-2~all~insert_cask~default-1-null.142^v93^chatsearchT3_1"}}] [.reference_item style="max-width: 50%"] - *2* *3* [LeetCode第十一题: 盛最多水的容器 (Java)](https://blog.csdn.net/a1111116/article/details/124206005)[target="_blank" data-report-click={"spm":"1018.2226.3001.9630","extra":{"utm_source":"vip_chatgpt_common_search_pc_result","utm_medium":"distribute.pc_search_result.none-task-cask-2~all~insert_cask~default-1-null.142^v93^chatsearchT3_1"}}] [.reference_item style="max-width: 50%"] [ .reference_list ]

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值